From 48999f99370edcf2db2e8717b9af966f6cb3683a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 09 2020 04:28:21 +0000
Subject: [PATCH 226/2232] Merge pull request #91 from dtolnay/unwindsafe


Accept non-UnwindSafe extern Rust types in extern Rust signatures
---

diff --git a/src/unwind.rs b/src/unwind.rs
index 070aa28..abb7b92 100644
--- a/src/unwind.rs
+++ b/src/unwind.rs
@@ -1,12 +1,16 @@
 use std::io::{self, Write};
-use std::panic::{self, UnwindSafe};
+use std::panic::{self, AssertUnwindSafe};
 use std::process;
 
 pub fn catch_unwind<F, R>(label: &'static str, foreign_call: F) -> R
 where
-    F: FnOnce() -> R + UnwindSafe,
+    F: FnOnce() -> R,
 {
-    match panic::catch_unwind(foreign_call) {
+    // Regarding the AssertUnwindSafe: we immediately abort on panic so it
+    // doesn't matter whether the types involved are unwind-safe. The UnwindSafe
+    // bound on catch_unwind is about ensuring nothing is in a broken state if
+    // your program plans to continue after the panic.
+    match panic::catch_unwind(AssertUnwindSafe(foreign_call)) {
         Ok(ret) => ret,
         Err(_) => abort(label),
     }

